<?php
/**
 * Author: lopiu
 * Date: 06.07.2020
 * Time: 22:41
 */

namespace Battles;

use Battles\Database\DBPDO;
use stdClass;

class DressedItems
{
    private $USERID;
    private $dressedItem;
    private static $db;

    /**
     * DressedItems constructor.
     * @param int   $user_id ID игрока.
     */
    public function __construct(int $user_id)
    {
        self::$db = DBPDO::INIT();
        $this->USERID = $user_id;
    }

    public static function getDressedItemBySlot($itemSlot, $ownerId)
    {
        return self::$db->fetch('SELECT *, COUNT(1) AS count FROM inventory WHERE owner_id = ? AND dressed_slot = ?', [$ownerId, $itemSlot]);
    }

    public function getItemsInSlots(): stdClass
    {
        $items = self::$db->ofetchALL('SELECT * FROM inventory WHERE owner_id = ? AND dressed_slot > 0', $this->USERID);
        $this->dressedItem = new stdClass();
        foreach ($items as $item) {
            $i = $item->dressed_slot;
            $this->dressedItem->$i = $item;
        }
        return $this->dressedItem;
    }

    /**
     * Снимает с предмета статус одетого на персонажа в определённом слоте персонажа.
     * @param $slot_id - номер слота.
     */
    public function undressItem($slot_id)
    {
        self::getItemsInSlots();
        // Проверяем, что используется один из 12 слотов и наличие предмета в слоте.
        if (in_array($slot_id, Item::ITEM_TYPES_ALLOWED_IN_SLOTS) && $this->dressedItem->$slot_id) {
            self::$db->execute('UPDATE inventory SET dressed_slot = 0 WHERE dressed_slot = ? AND owner_id = ?', [$slot_id, $this->USERID]);
        }
    }
    public static function undressAllItems($user_id)
    {
        return self::$db->execute('UPDATE inventory SET dressed_slot = 0 WHERE dressed_slot BETWEEN 1 AND 12 AND owner_id = ?', $user_id);
    }
}